; **************************************************************************
; Name     : LE DERVICHE TOURNEUR ( Adaptation 1 )
; Type     : CRACKME
;
; Date     : 20/01/2003
; Asm      : MASM 7
; Author   : LISE_GRIM
; **************************************************************************

.486p
.model	  flat, stdcall  
option	  casemap :none 

; --------------------------------------------------------------------------
;				IMPORTS
; --------------------------------------------------------------------------
include		\MASM32\INCLUDE\windows.inc
include		\MASM32\INCLUDE\gdi32.inc
include		\MASM32\INCLUDE\user32.inc
include		\MASM32\INCLUDE\kernel32.inc
include		\MASM32\INCLUDE\winmm.inc
include		\MASM32\INCLUDE\comctl32.inc
include		\MASM32\INCLUDE\comdlg32.inc


includelib	\MASM32\LIB\gdi32.lib
includelib	\MASM32\LIB\user32.lib
includelib	\MASM32\LIB\kernel32.lib
includelib	\MASM32\LIB\winmm.lib
includelib	\MASM32\LIB\comctl32.lib
includelib	\MASM32\LIB\comdlg32.lib
      
WinMain		PROTO :DWORD, :DWORD, :DWORD, :DWORD
WndProc		PROTO :DWORD, :DWORD, :DWORD, :DWORD
DlgAboutProc	PROTO :DWORD, :DWORD, :DWORD, :DWORD
DlgMainProc	PROTO :DWORD, :DWORD, :DWORD, :DWORD

; --------------------------------------------------------------------------
;				DATA
; --------------------------------------------------------------------------
.DATA


WaitTime	dd 2400
; --------------------------------------------------------------------------
;				DATA?
; --------------------------------------------------------------------------
.DATA?

hSplash		dd ?
hInstance	dd ?
RsrcHand	dd ?
RsrcSize	dd ?
RsrcPoint	dd ?
tc		dd ?
hOkButton	dd ?
hExitButton	dd ?
hInfoButton	dd ?

; --------------------------------------------------------------------------
;				CONST
; --------------------------------------------------------------------------
.CONST

PictureW		equ	275
PictureH		equ	419
IDD_DIALOGBOX1		equ	101
IDD_DIALOGBOX2		equ	102
IDI_ICON		equ	103
IDB_BITMAP_WIA		equ	104
IDB_BITMAP_DERVICHE	equ	105
IDS_SON			equ	106
IDB_BITMAP_IRRITANT	equ	107
IDB_BITMAP_BIOLOGIE	equ	108
IDC_PROG		equ	1001
IDC_INFO		equ	1002
IDC_EXIT		equ	1003
IDC_DLGBOX		equ	1004
IDC_INFO_OK		equ	2001
IDC_STATIC		equ	-1


; --------------------------------------------------------------------------
;				CODE
; --------------------------------------------------------------------------
.CODE

start:
	
	pushad
	xor	ecx, ecx
	call	CodeBeginning

	ClassName       db "cws_class",0
	DisplayName     db "...Loading",0
	RsrcName        db "RANGE",0
	RsrcType        db "RGN",0

	CodeBeginning:
	pop	ebx
	popad
	push	NULL
        call	GetModuleHandle		; invoke GetModuleHandle, NULL
        mov     hInstance, eax
	push	SW_SHOWDEFAULT
	push	NULL
	push	NULL
	push	hInstance
	call	WinMain		        ; invoke WinMain,hInstance,NULL,NULL,SW_SHOWDEFAULT

	push	NULL
	push	offset DlgMainProc
	push	NULL
	push	IDD_DIALOGBOX1
	push	hInstance
	call	DialogBoxParamA		; invoke DialogBoxParam, hInstance, IDD_DIALOGBOX1, NULL, offset DlgMainProc, 0
	
	push	NULL
	call	ExitProcess		; invoke ExitProcess, NULL

WinMain         PROC	hInst		:DWORD,
			hPrevInst	:DWORD,
			CmdLine		:DWORD,
			CmdShow		:DWORD
	                LOCAL	wc	:WNDCLASSEX
	                LOCAL	msg	:MSG

        mov     wc.cbSize,sizeof WNDCLASSEX
        mov     wc.style,CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
        mov     wc.lpfnWndProc,offset WndProc
        mov     wc.cbClsExtra,NULL
        mov     wc.cbWndExtra,NULL      
        push    hInst
        pop     wc.hInstance
	push	IDB_BITMAP_WIA
	push	hInst
	call	LoadBitmapA			; invoke  LoadBitmap, hInst, IDB_BITMAP_WIA
	push	eax
	call	CreatePatternBrush		; invoke  CreatePatternBrush,eax
        mov     wc.hbrBackground,eax
        mov     wc.lpszMenuName,NULL
        mov     wc.lpszClassName,offset ClassName             
        mov     wc.hIcon,NULL
	push	IDC_CROSS
	push	NULL
	call	LoadCursorA			; invoke  LoadCursor,NULL,IDC_CROSS
        mov     wc.hCursor,eax      
        mov     wc.hIconSm,NULL
	invoke  RegisterClassEx, ADDR wc
	push	SM_CXSCREEN
	call	GetSystemMetrics		; invoke  GetSystemMetrics,SM_CXSCREEN
        shr     eax,1
        sub     eax,PictureW/2
        push    eax
	push	SM_CYSCREEN
	call	GetSystemMetrics		; invoke  GetSystemMetrics,SM_CYSCREEN
        shr     eax,1
        sub     eax,PictureH/2
        pop     ebx
        invoke  CreateWindowEx,WS_EX_TOPMOST,ADDR ClassName,ADDR DisplayName,
                WS_POPUP or WS_BORDER,ebx,eax,PictureW,PictureH,NULL,NULL,hInst,NULL
        mov     hSplash,eax
	call	GetTickCount			; invoke GetTickCount
	mov	tc, eax
	push	offset RsrcType
	push	offset RsrcName
	push	hInstance
	call	FindResourceA			; invoke FindResource,hInstance,addr RsrcName,addr RsrcType
	mov     RsrcHand, eax
	push	eax
	push	hInstance
	call	LoadResource			; invoke  LoadResource,hInstance,eax
	mov     RsrcPoint, eax
	push	RsrcHand
	push	hInstance
	call	SizeofResource			; invoke  SizeofResource,hInstance,RsrcHand
	mov     RsrcSize, eax
	push	RsrcPoint
	call	LockResource			; invoke  LockResource,RsrcPoint
	mov     RsrcPoint, eax
	push	eax
	push	RsrcSize
	push	NULL
	call	ExtCreateRegion			; invoke  ExtCreateRegion,NULL,RsrcSize,eax
	push	TRUE
	push	eax
	push	hSplash
	call	SetWindowRgn			; invoke  SetWindowRgn, hSplash,eax,TRUE
	push	NULL
	push	NULL
	push	WM_DESTROY
	push	hSplash
	call	SendMessageA			; invoke  SendMessage, hSplash,WM_DESTROY,NULL,NULL
	push	SND_RESOURCE + SND_ASYNC
	push	NULL
	push	IDS_SON
	call	PlaySoundA			; invoke PlaySound, IDS_SON, NULL, SND_RESOURCE + SND_ASYNC
	push	SW_SHOWNORMAL
	push	hSplash
	call	ShowWindow			; invoke ShowWindow, hSplash,SW_SHOWNORMAL
	push	hSplash
        call	UpdateWindow
	mov	eax, WaitTime
	add	tc, eax
	@@:
	call	GetTickCount
	.if tc > eax
		jmp @B
	.endif

	push	NULL
	push	SC_CLOSE
	push	WM_SYSCOMMAND
	push	hSplash
	call	SendMessageA			; invoke SendMessage,hSplash,WM_SYSCOMMAND,SC_CLOSE,NULL


_Start:
        invoke  GetMessage,ADDR msg,NULL,0,0
        test    eax, eax
        jz      _Exit
        invoke  TranslateMessage,ADDR msg
        invoke  DispatchMessage,ADDR msg
        jmp     _Start
_Exit:


        mov     eax,msg.wParam
        ret

WinMain         ENDP
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;				GESTION	NAG
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
WndProc         PROC hWin :DWORD,uMsg :DWORD,wParam :DWORD,lParam :DWORD

	.IF     uMsg == WM_CREATE

	.ELSEIF uMsg == WM_COMMAND   
        	mov     eax,wParam
                                         
	.ELSEIF uMsg == WM_LBUTTONDOWN
		push	lParam
		push	HTCAPTION
		push	WM_NCLBUTTONDOWN
		push	hWin
		call	SendMessageA			; invoke  SendMessage,hWin,WM_NCLBUTTONDOWN,HTCAPTION,lParam
        
	.ELSEIF uMsg == WM_DESTROY
		push	NULL
		call	PostQuitMessage			; invoke  PostQuitMessage,NULL
        	xor     eax,eax
        	ret

	.ENDIF
	
	push	lParam
	push	wParam
	push	uMsg
	push	hWin
	call	DefWindowProcA				; invoke DefWindowProc,hWin,uMsg,wParam,lParam
        ret

WndProc         ENDP

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;				MAIN DIALOG
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DlgMainProc	PROC 	hWnd	:DWORD,
			uMsg	:DWORD,
			wParam	:DWORD,
			lParam	:DWORD

	mov	eax,uMsg    

	; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	.if eax == WM_CLOSE
		push	NULL
		push	hWnd
		call	EndDialog		; invoke EndDialog, hWnd, NULL

	; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	.elseif eax == WM_LBUTTONDOWN
		mov	eax, lParam
		push	eax
		push	HTCAPTION
		push	WM_NCLBUTTONDOWN
		push	hWnd
		call	PostMessageA		; invoke PostMessage, hWnd, WM_NCLBUTTONDOWN, HTCAPTION, eax

	; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	.elseif eax == WM_INITDIALOG
		xor	eax, eax
		push	IDI_ICON
		push	hInstance
		call	LoadIconA		; invoke LoadIcon, hInstance, IDI_ICON
		push	eax
		push	ICON_BIG
		push	WM_SETICON
		push	hWnd
		call	SendMessageA		; invoke SendMessage, hWnd, WM_SETICON, ICON_BIG, eax
		call	NomCaption
		db	"Le Derviche Tourneur !",0
		NomCaption:
		pop	eax		
		push	eax
		push	hWnd
		call	SetWindowTextA		; invoke SetWindowTextA, hWnd, eax
		push	IDB_BITMAP_BIOLOGIE
		push	hInstance
		call	LoadBitmapA		; invoke LoadBitmapA, hInstance, IDB_BITMAP_BIOLOGIE
		mov	[hInfoButton], eax
		push	IDB_BITMAP_IRRITANT
		push	hInstance
		call	LoadBitmapA		; invoke LoadBitmapA, hInstance, IDB_BITMAP_IRRITANT
		mov	[hExitButton], eax
		push	hInfoButton
		push	IMAGE_BITMAP
		push	BM_SETIMAGE
		push	IDC_INFO
		push	hWnd
		call	SendDlgItemMessageA	; invoke SendDlgItemMessage, hWnd, IDC_INFO, BM_SETIMAGE, IMAGE_BITMAP, hInfoButton
		push	hExitButton
		push	IMAGE_BITMAP
		push	BM_SETIMAGE
		push	IDC_EXIT
		push	hWnd
		call	SendDlgItemMessageA	; invoke SendDlgItemMessage, hWnd, IDC_EXIT, BM_SETIMAGE, IMAGE_BITMAP, hExitButton
		Call	CrackedBy
		db	"CRACKED by personne :)",0
		CrackedBy:
		pop	eax
		push	eax
		push	IDC_DLGBOX
		push	hWnd
		call	SetDlgItemTextA		; invoke SetDlgItemText, hWnd, IDC_DLGBOX, eax
	
	; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	.elseif eax == WM_CTLCOLORSTATIC
		push	0FFFFFFh
		push	wParam
		call	SetTextColor		; invoke SetTextColor,wParam, 0FFFFFFh
		push	TRANSPARENT
		push	wParam
		call	SetBkMode		; invoke SetBkMode, wParam, TRANSPARENT
		push	BLACK_BRUSH
		call	GetStockObject		; invoke GetStockObject, BLACK_BRUSH
		ret

	; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	.elseif eax == WM_CTLCOLORDLG
		push	TRANSPARENT
		push	wParam
		call	SetBkMode		; invoke SetBkMode, wParam, TRANSPARENT
		push	BLACK_BRUSH
		call	GetStockObject		; invoke GetStockObject, BLACK_BRUSH
		ret     

	; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	.elseif eax == WM_CTLCOLOREDIT
		push	0FFFFFFh
		push	wParam
		call	SetTextColor		; invoke SetTextColor,wParam, 0FFFFFFh
		push	TRANSPARENT
		push	wParam
		call	SetBkMode		; invoke SetBkMode, wParam, TRANSPARENT
		push	BLACK_BRUSH
		call	GetStockObject		; invoke GetStockObject, BLACK_BRUSH
		ret   
  
	; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	.elseif eax == WM_COMMAND
		mov	eax, wParam
		mov	edx, wParam
		shr	edx,16

		; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		.if ax == IDC_INFO
			push	NULL
			push	offset DlgAboutProc
			push	hWnd
			push	IDD_DIALOGBOX2
			push	hInstance
			call	DialogBoxParamA	;invoke DialogBoxParam, hInstance, IDD_DIALOGBOX2, hWnd, offset DlgAboutProc, 0

		; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		.elseif ax == IDC_EXIT
			push	NULL
			push	hWnd
			call	EndDialog		; invoke EndDialog, hWnd, NULL
		.endif
	.else
		mov	eax, FALSE
		ret
	.endif

	mov	eax,TRUE
	ret

DlgMainProc	ENDP

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;                             INFO DIALOG
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DlgAboutProc		PROC	hWnd	:DWORD,
			uMsg	:DWORD,
			wParam	:DWORD,
			lParam	:DWORD

	mov	eax, uMsg

	; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	.if eax == WM_CLOSE
		push	NULL
		push	hWnd
		call	EndDialog		; invoke EndDialog, hWnd, NULL

	; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	.elseif eax == WM_LBUTTONDOWN
		mov	eax, lParam
		push	eax
		push	HTCAPTION
		push	WM_NCLBUTTONDOWN
		push	hWnd
		call	PostMessageA		; invoke PostMessage, hWnd, WM_NCLBUTTONDOWN, HTCAPTION, eax

	; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	.elseif eax == WM_CTLCOLORSTATIC
		push	0FFFFFFh
		push	wParam
		call	SetTextColor		; invoke SetTextColor,wParam, 0FFFFFFh
		push	TRANSPARENT
		push	wParam
		call	SetBkMode		; invoke SetBkMode, wParam, TRANSPARENT
		push	BLACK_BRUSH
		call	GetStockObject		; invoke GetStockObject, BLACK_BRUSH
		ret

	; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	.elseif eax == WM_CTLCOLORDLG
		push	TRANSPARENT
		push	wParam
		call	SetBkMode		; invoke SetBkMode, wParam, TRANSPARENT
		push	BLACK_BRUSH
		call	GetStockObject		; invoke GetStockObject, BLACK_BRUSH
		ret     

	; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	.elseif eax == WM_CTLCOLOREDIT
		push	0FFFFFFh
		push	wParam
		call	SetTextColor		; invoke SetTextColor,wParam, 0FFFFFFh
		push	TRANSPARENT
		push	wParam
		call	SetBkMode		; invoke SetBkMode, wParam, TRANSPARENT
		push	BLACK_BRUSH
		call	GetStockObject		; invoke GetStockObject, BLACK_BRUSH
		ret   
  
	; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	.elseif eax == WM_INITDIALOG
		xor	eax, eax
		push	SND_RESOURCE + SND_ASYNC
		push	NULL
		push	IDS_SON
		call	PlaySound			; invoke PlaySound, IDS_SON, NULL, SND_RESOURCE + SND_ASYNC
		push	IDB_BITMAP_IRRITANT
		push	hInstance
		call	LoadBitmapA			; invoke LoadBitmapA, hInstance, IDB_BITMAP_IRRITANT
		mov	[hOkButton], eax
		push	hOkButton
		push	IMAGE_BITMAP
		push	BM_SETIMAGE
		push	IDC_INFO_OK
		push	hWnd
		call	SendDlgItemMessageA		; invoke SendDlgItemMessage, hWnd, IDC_INFO_OK, BM_SETIMAGE, IMAGE_BITMAP, hOkButton
  
	; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	.elseif eax == WM_COMMAND
		mov	eax, wParam
		mov	edx, wParam
		shr	edx, 16

           ; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		.if ax == IDC_INFO_OK
			push	eax
			push	hWnd
			call	EndDialog		; invoke EndDialog, hWnd, eax

		.endif
	.else
		mov	eax, FALSE
		ret
	.endif
   
	mov	eax,TRUE
	ret

DlgAboutProc	ENDP
; --------------------------------------------------------------------------
END		start
